--------------------------------------------------------------------------------
-- Weapon Vodoo
-- Script by Loooser, August 2011, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if loooser==nil then loooser={} end
loooser.vodoo={}
loooser.vodoo.fig={}

-- Load & Prepare Ressources
loooser.vodoo.gfx_wpn=loadgfx("weapons/vodoo.png")								-- Weapon Image
setmidhandle(loooser.vodoo.gfx_wpn)
loooser.vodoo.sfx_attack=loadsfx("throw.ogg")
loooser.vodoo.sfx_setv=loadsfx("selfhealing.ogg")											-- Attack Sound

--------------------------------------------------------------------------------
-- Weapon: vodoo
--------------------------------------------------------------------------------

loooser.vodoo.id=addweapon("loooser.vodoo","Vodoo",loooser.vodoo.gfx_wpn,0)	-- Add Weapon (0 use)

function loooser.vodoo.draw()															-- Draw
	-- Decrease Timer (used for animation)
	if weapon_timer>0.0 then
		weapon_timer=weapon_timer-0.5
	end

	if vplayer==nil or vplayer==0 then
	hudpositioning(pos_invisible)
	hudinfo("Click a player to control with your vodoo!")
	else
	hudinfo("Now throw your vodoo!")
	-- Draw
	if weapon_shots==0 then
	if getplayeraction(0)==0 then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(-getplayerdirection(0),1)
		setrotation(getplayerrotation(0)-(90-(weapon_timer*3))*(getplayerdirection(0)))
		drawimage(loooser.vodoo.gfx_wpn,getplayerx(0)+getplayerdirection(0)*7,getplayery(0))
	end
	end
	-- HUD Crosshair
	if weapon_shots==0 then
		hudcrosshair(6,3)
	end
	end
	if weapon_charge>0 and weapon_shots==0 then
		hudchargebar(weapon_charge,100)
	end
end

function loooser.vodoo.attack(attack)
	if (weapon_position==1) then
		weapon_position=0
		vplayer=0
		if collision(col3x3,weapon_x,weapon_y,0,1)==1 then
			if playercollision()~=0 then
				if getplayerhealth(playercollision())>0 and playercollision()~=playercurrent() then
					vplayer=playercollision()
					playsound(loooser.vodoo.sfx_setv)
					particle(p_ring,getplayerx(0),getplayery(0))
				end
			end
		end
	end													-- Attack
	if (weapon_shots<=0) and vplayer~=nil and vplayer~=0 then
		if (attack==1) then
			weapon_charge=weapon_charge+1
		end
		if (attack==0 and weapon_charge>0) or (weapon_charge>=100) then
			-- No more weapon switching!
			useweapon(0)
			playsound(loooser.vodoo.sfx_attack)
			weapon_shots=weapon_shots+1
			id=createprojectile(loooser.vodoo.fig.id)
			projectiles[id]={}
			-- Ignore collision with current player at beginning
			projectiles[id].ignore=playercurrent()
			-- Initial movement
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*20
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*20
			projectiles[id].x=getplayerx(0)+projectiles[id].sx
			projectiles[id].y=getplayery(0)+projectiles[id].sy
			-- Set speed of projectile
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*(weapon_charge/100.0)*10.0
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*(weapon_charge/100.0)*10.0
			projectiles[id].player=vplayer
			projectiles[id].psx=projectiles[id].sx*2.5
			projectiles[id].psy=projectiles[id].sy*2.5
			projectiles[id].timer=250
			projectiles[id].water=1
			projectiles[id].rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
			
			-- End Turn
			endturn()
		end
		
	end
end


--------------------------------------------------------------------------------
-- Projectile: vodoo
--------------------------------------------------------------------------------

loooser.vodoo.fig.id=addprojectile("loooser.vodoo.fig")	-- Add Projectile

function loooser.vodoo.fig.draw(id)						-- Draw
	if projectiles[id].timer>=0 then
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	projectiles[id].rot=projectiles[id].rot+10
	setrotation(projectiles[id].rot)
	-- Draw projectile
	drawimage(loooser.vodoo.gfx_wpn,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
	end
end

function loooser.vodoo.fig.update(id)						-- Update
	-- Gravity influence on speed
	projectiles[id].sy=projectiles[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		-- Move X
		projectiles[id].x=projectiles[id].x+msubx
		if collision(col5x5,projectiles[id].x,projectiles[id].y)==1 then
			if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
				if (math.abs(projectiles[id].sx)>0.5) then playsound(cc.grenade.sfx_bounce) end
				projectiles[id].x=projectiles[id].x-msubx
				projectiles[id].sx=-projectiles[id].sx*0.3
				msubx=-msubx*0.3
			end
		else
			projectiles[id].ignore=0
		end
		-- Move Y
		projectiles[id].y=projectiles[id].y+msuby
		if collision(col5x5,projectiles[id].x,projectiles[id].y)==1 then
			if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
				if (math.abs(projectiles[id].sy)>0.5) then playsound(cc.grenade.sfx_bounce) end
				projectiles[id].y=projectiles[id].y-msuby
				projectiles[id].sy=-projectiles[id].sy*0.3
				msuby=-msuby*0.3
				projectiles[id].sx=projectiles[id].sx*0.9
				msubx=msubx*0.9
			end
		else
			projectiles[id].ignore=0
		end		
		-- Water
		if (projectiles[id].y)>getwatery()+5 and projectiles[id].water==1 then
			projectiles[id].timer=0
			projectiles[id].water=0
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			break
		end
	end
	-- Timer
	projectiles[id].timer=projectiles[id].timer-1
	if projectiles[id].timer<=-50 then
		playerpush(projectiles[id].player,projectiles[id].psx,projectiles[id].psy)
		playsound(loooser.vodoo.sfx_attack)
		vplayer=0
		-- Free projectile
		freeprojectile(id)
	end
	if projectiles[id].timer<=-20 then
		playerstate(projectiles[id].player,state_confused,1)
	end
	if projectiles[id].timer>=0 then
	-- Scroll to projectile
	scroll(projectiles[id].x,projectiles[id].y)
	else
	scroll(getplayerx(projectiles[id].player),getplayery(projectiles[id].player))
	end
end